/*
 * Copyright (c) 2026 University of Insubria <https://www.uninsubria.it>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version. All we ask is that proper credit is given
 * for our work, which includes - but is not limited to - adding the above
 * copyright notice to the beginning of your source code files, and to any
 * copyright notice that you may distribute with programs based on this work.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.
 * <https://fsf.org/>
 */

package qsardes.atomconst;

import java.util.HashMap;
import java.util.Map;
import org.openscience.cdk.interfaces.IAtom;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.qsar.AtomValenceTool;
import org.openscience.cdk.tools.manipulator.AtomContainerManipulator;
import qsardes.molecule.Molecule;

/**
 * Gets the atomic valence.
 *
 * @author Nicola Chirico
 */
public final class AtomConstValence implements AtomConstFunctionCall
{
    public AtomConstValence()
    {
    }

    @Override
    public AtomConstResult call(Molecule mol)
    {
        IAtomContainer iac = mol.get_atom_container();

        final int ATOM_COUNT = iac.getAtomCount();

        Map<IAtom, Double> map = new HashMap<>();

        double[] const_val = new double[ATOM_COUNT];

        for (int i = 0; i < ATOM_COUNT; i++) {
            IAtom atom = iac.getAtom(i);

            int atomic_number = atom.getAtomicNumber();

            if (atomic_number != 1) {
                int valence = AtomValenceTool.getValence(atom);

                int h_count = AtomContainerManipulator
                        .countHydrogens(iac, atom);

                double delta_v = (double) (valence - h_count)
                        / (double) (atomic_number - valence - 1);

                const_val[i] = delta_v;
                map.put(atom, const_val[i]);
            } else {
                const_val[i] = 0.0;
                map.put(atom, const_val[i]);
            }
        }

        return new AtomConstResult(Double.NaN, map, const_val);
    }
}
